<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>LibGE: src/Tree.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="cropped-BDS-Logo-1.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibGE
   &#160;<span id="projectnumber">0.31.0</span>
   </div>
   <div id="projectbrief">A c++ GE implementation</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Tree.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_tree_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Tree.h -*- C++ -*-</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef _TREE_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define _TREE_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">/* This is a templated class that implements an n-ary tree.                  */</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">//#include &quot;libGEdefs.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include&lt;vector&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">using namespace </span>std;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="class_tree.html">   17</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_tree.html">Tree</a>;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">class </span><a class="code" href="class_tree.html">Tree</a>: <span class="keyword">public</span> vector&lt;Tree&lt;T&gt; &gt;{</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <a class="code" href="class_tree.html">Tree</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>=1,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>=1);</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <a class="code" href="class_tree.html">Tree</a>(<span class="keyword">const</span> T&amp;,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>=1,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>=1);</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        <a class="code" href="class_tree.html">Tree</a>(<span class="keyword">const</span> <a class="code" href="class_tree.html">Tree&lt;T&gt;</a>&amp;);</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        ~<a class="code" href="class_tree.html">Tree</a>();</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getDepth() <span class="keyword">const</span>;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="keywordtype">void</span> setDepth(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getCurrentLevel() <span class="keyword">const</span>;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="keywordtype">void</span> setCurrentLevel(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keyword">const</span> T getData() <span class="keyword">const</span>;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keywordtype">void</span> setData(<span class="keyword">const</span> T&amp;);</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keywordtype">bool</span> getValid() <span class="keyword">const</span>;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="keywordtype">void</span> setValid(<span class="keyword">const</span> <span class="keywordtype">bool</span>);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        T data;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> depth;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> currentLevel;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keywordtype">bool</span> valid;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;};</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment">// Constructor; initialises depth and current level.</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="class_tree.html#ad25b364afa8a3d318c9f029379b40a29">   44</a></span>&#160;<a class="code" href="class_tree.html#ad25b364afa8a3d318c9f029379b40a29">Tree&lt;T&gt;::Tree</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> newDepth,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> newCurrentLevel):</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    depth(newDepth),currentLevel(newCurrentLevel){</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;Tree&lt;T&gt;::Tree(const unsigned int, const unsigned int)&#39; called\n&quot;</span>;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <a class="code" href="class_tree.html#a113d512a32719bd7ca84d95a0af9a569">setValid</a>(<span class="keyword">false</span>);</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;}</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment">// Constructor; initialises data to match arguments.</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="class_tree.html#a778b842a28020b02f6b34f2a61451c25">   55</a></span>&#160;<a class="code" href="class_tree.html#ad25b364afa8a3d318c9f029379b40a29">Tree&lt;T&gt;::Tree</a>(<span class="keyword">const</span> T &amp;newData,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> newCurrentLevel,</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> newDepth):data(newData),depth(newDepth),</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        currentLevel(newCurrentLevel){</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;Tree&lt;T&gt;::Tree(const T&amp;, const unsigned int, const unsigned int)&#39; called\n&quot;</span>;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <a class="code" href="class_tree.html#a113d512a32719bd7ca84d95a0af9a569">setValid</a>(<span class="keyword">true</span>);</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;}</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment">// Copy constructor.</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="class_tree.html#a42310d852cd0998fbb46829b22cbc3e8">   67</a></span>&#160;<a class="code" href="class_tree.html#ad25b364afa8a3d318c9f029379b40a29">Tree&lt;T&gt;::Tree</a>(<span class="keyword">const</span> <a class="code" href="class_tree.html">Tree&lt;T&gt;</a> &amp;copy):vector&lt;<a class="code" href="class_tree.html">Tree</a>&lt;T&gt; &gt;(copy){</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;Tree&lt;T&gt;::Tree(const Tree&lt;T&gt;&amp;)&#39; called\n&quot;</span>;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <a class="code" href="class_tree.html#a93c745ff46b227da8387ce7d76047e84">setData</a>(copy.<a class="code" href="class_tree.html#a0873bded62a93b11c59ac3bd7611a787">getData</a>());</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <a class="code" href="class_tree.html#a88ac234f0b0fa121e7428a4137f805dc">setDepth</a>(copy.<a class="code" href="class_tree.html#a9a28225bf5cd7fb9a368f45eda53675e">getDepth</a>());</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <a class="code" href="class_tree.html#afe81138ebb2a19e433cbc33989f6c022">setCurrentLevel</a>(copy.<a class="code" href="class_tree.html#af96086869a67183512d5307c8f7eba5c">getCurrentLevel</a>());</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <a class="code" href="class_tree.html#a113d512a32719bd7ca84d95a0af9a569">setValid</a>(copy.<a class="code" href="class_tree.html#a363fb6c488cae2435ce341d7b8a612ed">getValid</a>());</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;}</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">// Destructor.</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="class_tree.html#a04affc46d89a0ef5d517ab685c9c346e">   80</a></span>&#160;<a class="code" href="class_tree.html#a04affc46d89a0ef5d517ab685c9c346e">Tree&lt;T&gt;::~Tree</a>(){</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;Tree&lt;T&gt;::~Tree()&#39; called\n&quot;</span>;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;}</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160; </div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment">// Return depth from this node until the deepest leaf.</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="class_tree.html#a9a28225bf5cd7fb9a368f45eda53675e">   89</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="class_tree.html#a9a28225bf5cd7fb9a368f45eda53675e">Tree&lt;T&gt;::getDepth</a>()<span class="keyword"> const</span>{</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;unsigned int Tree&lt;T&gt;::getDepth() const&#39; called\n&quot;</span>;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="keywordflow">return</span> depth;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;}</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment">// Set new depth of this node.</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="class_tree.html#a88ac234f0b0fa121e7428a4137f805dc">   99</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_tree.html#a88ac234f0b0fa121e7428a4137f805dc">Tree&lt;T&gt;::setDepth</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> newDepth){</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;void Tree&lt;T&gt;::setDepth(const unsigned int)&#39; called\n&quot;</span>;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    depth=newDepth;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;}</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="comment">// Return level of this node.</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="class_tree.html#af96086869a67183512d5307c8f7eba5c">  109</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="class_tree.html#af96086869a67183512d5307c8f7eba5c">Tree&lt;T&gt;::getCurrentLevel</a>()<span class="keyword"> const</span>{</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;unsigned int Tree&lt;T&gt;::getCurrentLevel() const&#39; called\n&quot;</span>;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keywordflow">return</span> currentLevel;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;}</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="comment">// Set new current level of this node.</span></div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="class_tree.html#afe81138ebb2a19e433cbc33989f6c022">  119</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_tree.html#afe81138ebb2a19e433cbc33989f6c022">Tree&lt;T&gt;::setCurrentLevel</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> newCurrentLevel){</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;void Tree&lt;T&gt;::setCurrentLevel(const unsigned int)&#39; called\n&quot;</span>;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    currentLevel=newCurrentLevel;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;}</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="comment">// Return data stored in this node.</span></div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00129"></a><span class="lineno"><a class="line" href="class_tree.html#a0873bded62a93b11c59ac3bd7611a787">  129</a></span>&#160;<span class="keyword">const</span> T <a class="code" href="class_tree.html#a0873bded62a93b11c59ac3bd7611a787">Tree&lt;T&gt;::getData</a>()<span class="keyword"> const</span>{</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;const T Tree&lt;T&gt;::getData() const&#39; called\n&quot;</span>;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordflow">if</span>(getValid()){</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <span class="keywordflow">return</span> data;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    }</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="keywordflow">else</span>{</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    }</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;}</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160; </div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="comment">// Set data to store in this node.</span></div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00144"></a><span class="lineno"><a class="line" href="class_tree.html#a93c745ff46b227da8387ce7d76047e84">  144</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_tree.html#a93c745ff46b227da8387ce7d76047e84">Tree&lt;T&gt;::setData</a>(<span class="keyword">const</span> T &amp;newData){</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;void Tree&lt;T&gt;::setData(const T&amp;)&#39; called\n&quot;</span>;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    data=newData;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    setValid(<span class="keyword">true</span>);</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;}</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160; </div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;<span class="comment">// Return validity of this node.</span></div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00155"></a><span class="lineno"><a class="line" href="class_tree.html#a363fb6c488cae2435ce341d7b8a612ed">  155</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="class_tree.html#a363fb6c488cae2435ce341d7b8a612ed">Tree&lt;T&gt;::getValid</a>()<span class="keyword"> const</span>{</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;bool Tree&lt;T&gt;::getValid() const&#39; called\n&quot;</span>;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <span class="keywordflow">return</span> valid;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;}</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160; </div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;<span class="comment">// Set validity of this node.</span></div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00165"></a><span class="lineno"><a class="line" href="class_tree.html#a113d512a32719bd7ca84d95a0af9a569">  165</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_tree.html#a113d512a32719bd7ca84d95a0af9a569">Tree&lt;T&gt;::setValid</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span> newValid){</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="preprocessor">#if (DEBUG_LEVEL &gt;= 2)</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    cerr &lt;&lt; <span class="stringliteral">&quot;&#39;void Tree&lt;T&gt;::setValid(const bool)&#39; called\n&quot;</span>;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    valid=newValid;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;}</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclass_tree_html_ad25b364afa8a3d318c9f029379b40a29"><div class="ttname"><a href="class_tree.html#ad25b364afa8a3d318c9f029379b40a29">Tree::Tree</a></div><div class="ttdeci">Tree(const unsigned int=1, const unsigned int=1)</div><div class="ttdef"><b>Definition:</b> Tree.h:44</div></div>
<div class="ttc" id="aclass_tree_html_a9a28225bf5cd7fb9a368f45eda53675e"><div class="ttname"><a href="class_tree.html#a9a28225bf5cd7fb9a368f45eda53675e">Tree::getDepth</a></div><div class="ttdeci">unsigned int getDepth() const</div><div class="ttdef"><b>Definition:</b> Tree.h:89</div></div>
<div class="ttc" id="aclass_tree_html_afe81138ebb2a19e433cbc33989f6c022"><div class="ttname"><a href="class_tree.html#afe81138ebb2a19e433cbc33989f6c022">Tree::setCurrentLevel</a></div><div class="ttdeci">void setCurrentLevel(const unsigned int)</div><div class="ttdef"><b>Definition:</b> Tree.h:119</div></div>
<div class="ttc" id="aclass_tree_html_a04affc46d89a0ef5d517ab685c9c346e"><div class="ttname"><a href="class_tree.html#a04affc46d89a0ef5d517ab685c9c346e">Tree::~Tree</a></div><div class="ttdeci">~Tree()</div><div class="ttdef"><b>Definition:</b> Tree.h:80</div></div>
<div class="ttc" id="aclass_tree_html_a93c745ff46b227da8387ce7d76047e84"><div class="ttname"><a href="class_tree.html#a93c745ff46b227da8387ce7d76047e84">Tree::setData</a></div><div class="ttdeci">void setData(const T &amp;)</div><div class="ttdef"><b>Definition:</b> Tree.h:144</div></div>
<div class="ttc" id="aclass_tree_html_af96086869a67183512d5307c8f7eba5c"><div class="ttname"><a href="class_tree.html#af96086869a67183512d5307c8f7eba5c">Tree::getCurrentLevel</a></div><div class="ttdeci">unsigned int getCurrentLevel() const</div><div class="ttdef"><b>Definition:</b> Tree.h:109</div></div>
<div class="ttc" id="aclass_tree_html_a113d512a32719bd7ca84d95a0af9a569"><div class="ttname"><a href="class_tree.html#a113d512a32719bd7ca84d95a0af9a569">Tree::setValid</a></div><div class="ttdeci">void setValid(const bool)</div><div class="ttdef"><b>Definition:</b> Tree.h:165</div></div>
<div class="ttc" id="aclass_tree_html_a363fb6c488cae2435ce341d7b8a612ed"><div class="ttname"><a href="class_tree.html#a363fb6c488cae2435ce341d7b8a612ed">Tree::getValid</a></div><div class="ttdeci">bool getValid() const</div><div class="ttdef"><b>Definition:</b> Tree.h:155</div></div>
<div class="ttc" id="aclass_tree_html_a88ac234f0b0fa121e7428a4137f805dc"><div class="ttname"><a href="class_tree.html#a88ac234f0b0fa121e7428a4137f805dc">Tree::setDepth</a></div><div class="ttdeci">void setDepth(const unsigned int)</div><div class="ttdef"><b>Definition:</b> Tree.h:99</div></div>
<div class="ttc" id="aclass_tree_html"><div class="ttname"><a href="class_tree.html">Tree</a></div><div class="ttdef"><b>Definition:</b> Tree.h:17</div></div>
<div class="ttc" id="aclass_tree_html_a0873bded62a93b11c59ac3bd7611a787"><div class="ttname"><a href="class_tree.html#a0873bded62a93b11c59ac3bd7611a787">Tree::getData</a></div><div class="ttdeci">const T getData() const</div><div class="ttdef"><b>Definition:</b> Tree.h:129</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
